CON    
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  ptr2_S2A_Cmd     = 0
  ptr2_A2S_Status  = ptr2_S2A_Cmd    + 4 'adresses relative to par from cognew(@entry, @xStart)

  ptr2TestVar1     = ptr2_A2S_Status + 4 
  ptr2TestVar2     = ptr2TestVar1    + 4
  ptr2HUB_RAM_Buff = ptr2TestVar2    + 4 

  A2S_idle                     =  1
  
  c_Wait_for_pulsetrain      = 10
  c_recording_for_pulsetrain = 20
  c_recording_finished       = 30

  c_ready_to_send_IR         = 110
  c_sending_IR               = 120
  c_sending_finished         = 130

  c_Prepare_for_recording    = 200
  c_Prepare_for_sending      = 210

  c_IR_Recv_Pin    =  2

  c_C3_LED         = 15
  c_LED_Left       = 16 
  c_LED_Middle     = 17 
  c_LED_Right      = 18


  c_ClockTicksPerSecond = 80_000_000 
  c_1microSecond        = 1_000_000

  c_10microSecs         = c_ClockTicksPerSecond / c_1microSecond * 10  - 12 'three PASM-commands means 12 clockticks

  c_NegEdgeDetectorNoPLL = %0_01110_000
  c_NoOfBitsPerLong = 32

  c_Buffer_Size    = 50'1250
  c_AheadTicks = 20
  c_Divisor    = 3  '3 results in a divisor 2^3 = 8  1/8
  c_DebugOn    = 0'120'0


VAR
  long S2A_Cmd    'variable for communicating between PASM-cog and SPIN 
  long A2S_Status 'variable for reading in SPIN writing in ASM   Assembler-->to-->SPIN
  long TestVar1
  long TestVar2

  long RecordBuffer [c_Buffer_Size]

  long Timer
  long Delay

  long ToggleStack[20]

  long i
  long Count

  
OBJ
  dbg   : "PASDebug"                '<---- Add for Debugger 
  ser   : "FullDuplexSerial"     

  
PUB Test_PASM_record_loop
  
  cognew (@entryMonoFlop,@S2A_Cmd)
  
  TestVar1 := 0
  TestVar2 := 0
  
  repeat i from 0 to c_Buffer_Size - 1
    RecordBuffer [i] := i + 255

  TestVar2 := c_DebugOn      
  if TestVar2 == 120     
    S2A_Cmd := c_Wait_for_pulsetrain
    cognew(@entryMeasureFreq,@S2A_Cmd) 'launch PASM-cog
    dbg.start(31,30,@entryMeasureFreq)                 '<---- Add for Debugger
    repeat
  
  ser.start(31,30,0,115200)
  ser.str(string(13,"ser.start(30,31,0,115200) done",13))
  
  cognew(Toggle_Pin(0, 4),@ToggleStack)
  ser.str(string("cognew(Toggle_Pin(0, 4),@ToggleStack)done",13))

  cognew(@entryMeasureFreq,@S2A_Cmd)
  ser.str(string("cognew(@entryMeasureFreq,0) done",13))

  S2A_Cmd := c_Wait_for_pulsetrain
  ser.str(string("ready for recording pulsetrain",13))

  repeat
    ser.str(string("wait for pulsetrain",13))
    'ser.str(string("PHSA="))
    'ser.dec(TestVar1)
    WaitCnt(ClkFreq + cnt)
  until S2A_Cmd == 0

  repeat i from 0 to c_Buffer_Size - 1
    ser.bin(RecordBuffer[i],32)
    ser.str(string(13))

  ser.str(string("recording of pulsetrain done",13))

  ser.str(string("clockticks from pulse to pulse TestVar1 "))
  ser.dec(TestVar1)
  ser.str(string(13))

  ser.str(string("_Period_8tel TestVar2 "))
  ser.dec(TestVar2)
  ser.str(string(13,13))

  repeat
  
  WaitCnt(ClkFreq + cnt)
   
  repeat
    S2A_Cmd := c_Wait_for_pulsetrain
    ser.str(string("ready for recording pulsetrain",13))
    
    repeat
      ser.str(string("recording pulsetrain",13))
      WaitCnt(ClkFreq + cnt)

    until S2A_Cmd == 0
    
    ser.str(string("recording of pulsetrain done",13))

    ser.str(string("clockticks from pulse to pulse "))
    ser.dec(TestVar1)
    ser.str(string(13,13))

    ser.str(string("_Period_8tel =   "))
    ser.dec(TestVar2)
    ser.str(string(13,13))
    WaitCnt(ClkFreq + cnt)
  

  {
  repeat i from 0 to c_Buffer_Size - 1
    ser.dec(RecordBuffer[i])
    ser.str(string(" "))
  }


PUB Toggle_Pin(p_IO_Pin, p_Delay)

  DIRA[p_IO_Pin] := 1

  Delay := ClkFreq / p_Delay '* 500
  Timer := cnt + Delay   

  repeat
    WaitCnt(Timer += Delay)
    !OUTA[p_IO_Pin]
    
      
DAT
              ORG 0
              
entryMeasureFreq
{
'  --------- Debugger Kernel add this at Entry (Addr 0) ---------
   long $34FC1202,$6CE81201,$83C120B,$8BC0E0A,$E87C0E03,$8BC0E0A
   long $EC7C0E05,$A0BC1207,$5C7C0003,$5C7C0003,$7FFC,$7FF8
'  --------------------------------------------------------------
}

StartOfCode   call       #SetOutPuts
              call       #Read_SPIN_CmdM
              call       #SetupCounterMode
              'initialise variables for recording IR-signalstates
              mov       _IR_Recv_Long,  #0                  'reset long containing bits of sampled pulsetrain

              mov       _HUB_Base_AdrM, par
              add       _HUB_Base_AdrM, #ptr2HUB_RAM_Buff
              mov       _HUB_Act_Idx, _HUB_Base_AdrM        'Reset BufferIndex to baseadress
              mov       _Buff_Count,    _BuffSize           'setup variable for buffer-filling-loop
              mov       _32Bit_Count,   #c_NoOfBitsPerLong  'setup variable for filling long with IR-statebits               
              mov       _Period_8Cycl,  #0                 

              mov       _CarrierOnFlag, #0      
              mov       _CarrierONCnt,  #0                 
              mov       _CarrierOffCnt, #0 
              mov       _NrOfPulses,    #0
              mov       _LastNoOfPulses,#0
              mov       _NewNoOfPulses, #0
              mov       _SumOfPulses,   #0
              mov       _PeriodFrac,    #1
              shl       _PeriodFrac,    #c_Divisor         '_PeriodFrac contains the fractional how often 
              
              call       #MeasureCarrierFreq
              'coming back from this subr means new carrier-period starts right now
              'the counter is already prepared through a mov PHSA, #0 to catch the next high-to-low-transition
              'and PHSA containing 1 (and not a highrer value)

              mov       _TestVar1M,     #0'_Period 
              mov       _TestVar2M,     _Period_8tel 
              mov       _SPIN_CmdM,     #1               'set Status to 0 to indicate command finished
              call      #Write_SPIN_CmdM
               
              xor       OutA,           _LED_RightM        'set bit "_LED_LeftM" in OutA-register to 1
              mov       PHSA,           #0

Record_IR_Bits_Loop
              waitcnt   _MFlopMatch,    _Period_8tel       'wait for 1/8 of a period
              mov       _NrOfPulses,    PHSA               'PHSA holds actual sum of pulses update actual number of pulses

              add       _Period_8Cycl,  #1                 'increment number of Period 8th cycles
              cmp       _Period_8Cycl,  _PeriodFrac wz     'check if a complete period is over
        if_nz jmp       #Record_IR_Bits_Loop               'only if period is over do the rest

              mov       PHSA,           #0
              mov       _Period_8Cycl,  #0                 'reset loopcounter
        
              cmp       _NrOfPulses,    #1 wc              'check if there were new pulses
        if_c  mov       _IR_Recv_Bit,   #0                 'no pulse received => set IR_Recv_Bit to 0
        if_nc mov       _IR_Recv_Bit,   #1                 'a pulse received => set IR_Recv_Bit to 1

              add       _IR_Recv_Long,  _IR_Recv_Bit       'add actual bit to long
              sub       _32Bit_Count,   #1 wz              'check for last loop within actual long          
        if_nz shl       _IR_Recv_Long,  #1                 'if not last bit shift bits 1 to the left

        if_z  call      #WriteLongToBuffer

        if_z  sub       _Buff_Count,    #1 wz              'if byte was written to buffer decrement _Buff_Count by one
        if_z  jmp       #Recording_finished                'if _Buff_Count reaches zero buffer is full 

              'mov       _NrOfPulses,    PHSA               'PHSA holds actual sum of pulses update actual number of pulses
              'cmp       _NrOfPulses,    #1 wc              'check if there were new pulses
        'if_nc or        OutA,           _VPTriggerPin      'if _NrOfPulses is >= 1 then the C-Flag is cleared
        'if_nc add       _TestVar1M,     #1
              jmp       #Record_IR_Bits_Loop
              
Recording_finished
              
              mov       _TestVar1M,     _Period
              'mov        _TestVar2M,     _Snapshot2
              'sub        _TestVar2M,     _Snapshot1

              mov       _SPIN_CmdM,     #0               'set Status to 0 to indicate command finished
              call      #Write_SPIN_CmdM

infLoop       nop
              jmp       #infLoop





'SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
'# START Subroutines
'#########################################################
SetOutPuts    mov       _BitMaskM,      _LED_LeftM
              or        _BitMaskM,      _LED_MiddleM
              or        _BitMaskM,      _LED_RightM
              'or        _BitMaskM,      _MonoFlopPin
              or        _BitMaskM,      _VPTriggerPin
              or        _BitMaskM,      _toggleBit
              or        DirA,           _BitMaskM          'set   bits of BitMakM in DirA-register to 1  
              andn      OutA,           _BitMaskM          'clear bits of BitMakM in OutA-register to 0

SetOutPuts_ret ret
'---------------------------------------------------------


'#########################################################
SetupCounterMode  'setup counter-mode and initialise INcS-Register and TSUM-register
 ' 3         2         1
 '10987654321098765432109876543210
 '10987654321098765432109876543210
'%-CMODEPLL--------B__PIN---A__PIN
'%00111000000000000000000000000011
  
              movi      CTRA,           #c_NegEdgeDetectorNoPLL  'setup counter for negative-edge-mode
              movs      CTRA,           #%000000010              'sense IO-pin 2
              mov       FRQA,           #1                       'load summand-register with 1
              mov       PHSA,           #0                       'load summerise-register with 0
SetupCounterMode_ret ret
'---------------------------------------------------------


'#########################################################
MeasureCarrierFreq
              or        OutA,           _LED_LeftM         'set bit "_LED_LeftM" in OutA-register to 1

              cmp        _TestVar2M,    #120 wz
        if_z  jmp        #PresetPeriod
              
              mov       _InputStateM,   #0                 'load BitPattern ZERO  
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until specified bit "_IR_Recv_Pin" is ZERO
                                                           'which means pulsetrain starts
              mov       _InputStateM,   #8                 'load bitpattern that should be matched
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until INA-registerbit specified in _IR_Recv_Pin2
                                                           'has the same state as in _InputStateM
              mov       _InputStateM,   #0                 'load BitPattern ZERO  
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until specified bit "_IR_Recv_Pin" is ZERO

              mov       _InputStateM,   #0                 'load BitPattern ZERO  
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until specified bit "_IR_Recv_Pin" is ZERO
                                                           'which means pulsetrain starts
              mov       _InputStateM,   #8                 'load bitpattern that should be matched
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until INA-registerbit specified in _IR_Recv_Pin2
                                                           'has the same state as in _InputStateM
              mov       _InputStateM,   #0                 'load BitPattern ZERO  
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until specified bit "_IR_Recv_Pin" is ZERO

              mov       _InputStateM,   #0                 'load BitPattern ZERO  
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until specified bit "_IR_Recv_Pin" is ZERO
                                                           'which means pulsetrain starts
              mov       _InputStateM,   #8                 'load bitpattern that should be matched
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until INA-registerbit specified in _IR_Recv_Pin2
                                                           'has the same state as in _InputStateM
              mov       _InputStateM,   #0                 'load BitPattern ZERO  
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until specified bit "_IR_Recv_Pin" is ZERO

              mov       _InputStateM,   #0                 'load BitPattern ZERO  
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until specified bit "_IR_Recv_Pin" is ZERO
                                                           'which means pulsetrain starts
              mov       _InputStateM,   #8                 'load bitpattern that should be matched
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until INA-registerbit specified in _IR_Recv_Pin2
                                                           'has the same state as in _InputStateM
              mov       _InputStateM,   #0                 'load BitPattern ZERO  
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until specified bit "_IR_Recv_Pin" is ZERO


              mov       _InputStateM,   #0                 'load BitPattern ZERO  
WaitIRPinLow  waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until specified bit "_IR_Recv_Pin" is ZERO
                                                           'which means pulsetrain starts
              mov       _FirstPulse,    cnt                'take snapshot of free running systemcounter

              or        OutA,           _LED_MiddleM       'set bit "_LED_MiddleM" in OutA-register to 1


              mov       _InputStateM,   #8                 'load bitpattern that should be matched
WaitIRPinHigh waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until INA-registerbit specified in _IR_Recv_Pin2
                                                           'has the same state as in _InputStateM
              mov       _InputStateM,   #0                 'load BitPattern ZERO  
WaitIRPinLow2 waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until specified bit "_IR_Recv_Pin" is ZERO
                                                           'which means pulsetrain starts
              mov       _SecondPulse,   cnt                'take snapshot of free running systemcounter

              andn      OutA,           _LED_LeftM         'clear bit "_LED_LeftM" in OutA-register to 0
              
              mov       _Period,        _SecondPulse
              sub       _Period,        _FirstPulse        'calculate clockticks of pulsedistance (=carrier-frequency)
              mov       _Period25,      _Period
              shr       _Period25,      #c_Divisor         'shr c_Divisor bits to the right means divide by 2^c_Divisor

              jmp       #here
PresetPeriod  mov       _Period,        _2000

              mov       _Period_8tel,   _Period
              shr       _Period_8tel,   #c_Divisor         'shr 3 bits to the right means divide by 2^3 = 8 - 1/8 of a period
              mov       _MFlopMatch,    _SecondPulse       'copy value of systemcounter-snapshot before 
              add       _MFlopMatch,    _Period            'add clockticks of 1 period
              sub       _MFlopMatch,    _AheadTicks        'substract clockticks to be ahead of the next high-to-low-transition              
              mov       PHSA,           #0                 'prepare counter to detect high-to-low-transition
              or        OutA,           _LED_MiddleM         'set bit "_LED_LeftM" in OutA-register to 1
              jmp       #MeasureCarrierFreq_ret
              
here          mov       _Period_8tel,   _Period
              shr       _Period_8tel,   #c_Divisor         'shr 3 bits to the right means divide by 2^3 = 8 - 1/8 of a period

              'wait until next pulse-period begins
              mov       _MFlopMatch,    _SecondPulse       'copy value of systemcounter-snapshot before 
              add       _MFlopMatch,    _Period            'add clockticks of 1 period
              sub       _MFlopMatch,    _AheadTicks        'substract clockticks to be ahead of the next high-to-low-transition

              waitcnt   _MFlopMatch,    _Period
              
              mov       PHSA,           #0                 'prepare counter to detect high-to-low-transition
              or        OutA,           _LED_MiddleM         'set bit "_LED_LeftM" in OutA-register to 1
MeasureCarrierFreq_ret ret
'---------------------------------------------------------


'#########################################################
WriteLongToBuffer
              wrlong    _IR_Recv_Long,  _HUB_Act_Idx        'write long to HUB-RAM
              add       _HUB_Act_Idx,   #4                  'set HUB-RAM-adress to next long
              
              mov       _IR_Recv_Long,  #0                  'reset long that contains sampled bits of pulsetrain
              mov       _32Bit_Count,   #c_NoOfBitsPerLong  'setup variable for filling long with IR-statebits               
WriteLongToBuffer_ret ret
'---------------------------------------------------------

              
'#########################################################
ReSyncToCarrier
              mov       _InputStateM,   #0                 'load BitPattern ZERO  
              waitpeq   _InputStateM,   _IR_Recv_Pin2      'wait until specified bit "_IR_Recv_Pin" is ZERO
              mov       _MFlopMatch,    cnt                'new snapshot of systemcounter
              add       _MFlopMatch,    _Period
              sub       _MFlopMatch,    _AheadTicks

              or        OutA,           _DebugPin
              add       _TestVar2M,     #1
              
              waitcnt   _MFlopMatch,    _Period
              'mov       _IR_Recv_Bit,   #1                 'resyncing means a pulse has occurred so set _IR_Recv_Bit to 1 
ReSyncToCarrier_ret ret
'---------------------------------------------------------


'#########################################################
Read_SPIN_CmdM                  
              mov       _HUB_Base_AdrM, par
              add       _HUB_Base_AdrM, #ptr2_S2A_Cmd
              rdlong    _SPIN_CmdM,     _HUB_Base_AdrM 

              mov       _HUB_Base_AdrM, par
              add       _HUB_Base_AdrM, #ptr2TestVar1
              rdlong    _TestVar1M,     _HUB_Base_AdrM

              mov       _HUB_Base_AdrM, par
              add       _HUB_Base_AdrM, #ptr2TestVar2
              rdlong    _TestVar2M,     _HUB_Base_AdrM

Read_SPIN_CmdM_ret ret
'---------------------------------------------------------


'#########################################################
Write_SPIN_CmdM                  
              mov       _HUB_Base_AdrM, par
              add       _HUB_Base_AdrM, #ptr2TestVar1
              wrlong    _TestVar1M,     _HUB_Base_AdrM

              mov       _HUB_Base_AdrM, par
              add       _HUB_Base_AdrM, #ptr2TestVar2
              wrlong    _TestVar2M,     _HUB_Base_AdrM

              mov       _HUB_Base_AdrM, par
              add       _HUB_Base_AdrM, #ptr2_S2A_Cmd
              wrlong    _SPIN_CmdM,     _HUB_Base_AdrM

Write_SPIN_CmdM_ret ret
'---------------------------------------------------------


              
_IR_Recv_Pin2 long |< 3
_MonoFlopPin  long |< c_IR_Recv_Pin
_DebugPin     long |< 5
_VPTriggerPin long |< 6

_10microSecs  long c_10microSecs

_toggleBit    long |< c_C3_LED

_LED_LeftM    long |< c_LED_Left
_LED_MiddleM  long |< c_LED_Middle     
_LED_RightM   long |< c_LED_Right      

_BuffSize     long c_Buffer_Size

_zero         long 0

_AheadTicks   long c_AheadTicks

_CarrierOnFlag long 1
_2000         long 2000


_SPIN_CmdM    res 1
_TestVar1M    res 1
_TestVar2M    res 1

_HUB_Act_Idx  res 1
_HUB_Base_AdrM res 1

_Buff_Count   res 1

_32Bit_Count  res 1

_FirstPulse   res 1
_SecondPulse  res 1

_Period       res 1
_Period25     res 1
_Period50     res 1
_Period75     res 1

_MFlopMatch   res 1
_EOSamplMatch res 1

_IR_Recv_Bit  res 1
_IR_Recv_Long res 1

_InputStateM  res 1

_BitMaskM     res 1

_dummyLongM   res 1

_NrOfPulses     res 1
_LastNoOfPulses res 1
_NewNoOfPulses  res 1
_SumOfPulses    res 1
_MatchVal       res 1
_Period_8tel    res 1
_Period_8Cycl   res 1
_CarrierOffCnt  res 1
_CarrierONCnt   res 1
_PeriodFrac     res 1
_Snapshot1      res 1
_Snapshot2      res 1
{
TestLoop      waitcnt   _MFlopMatch,    _Period_8tel       'wait for 1/8 of a period
              mov       _TestVar1M,     PHSA 
              call      #Write_SPIN_CmdM
              xor       OutA,           _LED_RightM         'set bit "_LED_LeftM" in OutA-register to 1
              jmp       #TestLoop

}

DAT
              ORG 0
              
entryMonoFlop
{
'  --------- Debugger Kernel add this at Entry (Addr 0) ---------
   long $34FC1202,$6CE81201,$83C120B,$8BC0E0A,$E87C0E03,$8BC0E0A
   long $EC7C0E05,$A0BC1207,$5C7C0003,$5C7C0003,$7FFC,$7FF8
'  --------------------------------------------------------------
}

c1SetOutPuts  mov       c1BitMask,      c1LED_LeftM
              or        c1BitMask,      c1LED_MiddleM
              or        c1BitMask,      c1LED_MiddleM
              or        c1BitMask,      c1MonoFlopPin
              
              or        DirA,           c1BitMask          'set   bits of BitMakM in DirA-register to 1  
              andn      OutA,           c1BitMask          'clear bits of BitMakM in OutA-register to 0
              'jmp       #SetOutPuts
 
c1MeasureCarrierFreq
              or        OutA,           c1LED_LeftM         'set bit "c1LED_LeftM" in OutA-register to 1
              'jmp       #c1MeasureCarrierFreq

              mov       c1InputState,   #0                 'load BitPattern ZERO  
c1WaitIRPinLow waitpeq   c1InputState,   c1_IR_RecvPin      'wait until specified bit "_IR_Recv_Pin" is ZERO
                                                           'which means pulsetrain starts
              mov       c1_FirstPulse,    cnt                'take snapshot of free running systemcounter

              or        OutA,           c1LED_MiddleM       'set bit "c1LED_MiddleM" in OutA-register to 1


              mov       c1InputState,   #8                 'load bitpattern that should be matched
c1WaitIRPinHigh waitpeq   c1InputState,   c1_IR_RecvPin      'wait until INA-registerbit specified in c1LED_MiddleM
                                                           'has the same state as in c1LED_MiddleM
              mov       c1InputState,   #0                 'load BitPattern ZERO  
c1WaitIRPinLow2 waitpeq   c1InputState,   c1_IR_RecvPin      'wait until specified bit "_IR_Recv_Pin" is ZERO
                                                           'which means pulsetrain starts
              mov       c1_SecondPulse,   cnt                'take snapshot of free running systemcounter

              andn      OutA,           c1LED_LeftM         'clear bit "c1LED_LeftM" in OutA-register to 0

              mov       c1Period,        c1_SecondPulse
              sub       c1Period,        c1_FirstPulse        'calculate clockticks of pulse
              mov       c1Period50,      c1Period
              shr       c1Period50,      #1                 'shr 1 bit to the right means divide by 2
              mov       c1Period75,      c1Period50
              shr       c1Period75,      #1                 'shr 1 bit to the right means divide by 2
              add       c1Period75,      c1Period50          'add half and a quarter period to obtain 75% of the period
              sub       c1Period75,      #12                'substract 12 clockticks for 3 command before waitcnt starts


'This part of the code acts as a Monoflop
'the code waits for a high-to-low-transition with the waitpeq-command
'then the specified pin is set high for a fixed time and set low again after this time.
'Then the code waits again for a high-to-low-transistion with the waitpeq-command  
WaitForTransition
              mov       c1InputState,  #0                  'load BitPattern ZERO  
              waitpeq   c1InputState,  c1_IR_RecvPin      'wait until specified bit "_IR_Recv_Pin" is ZERO
              
SetPinHigh    or        OutA,           c1MonoFlopPin       'set c1MonoFlopPin high 
              mov       c1MFlopMatch,   cnt 
              add       c1MFlopMatch,   c1Period50
              waitcnt   c1MFlopMatch,   c1Period50
SetPinLow     andn      OutA,           c1MonoFlopPin       'set c1MonoFlopPin low
              jmp       #WaitForTransition
              
c1MonoFlopPin long |< 2
c1_IR_RecvPin long |< 3
c110microSecs long c_10microSecs

c1LED_LeftM   long |< c_LED_Left
c1LED_MiddleM long |< c_LED_Middle     
c1LED_RightM  long |< c_LED_Right      

c1_FirstPulse res 1
c1_SecondPulse res 1

c1Period      res 1
c1Period50    res 1
c1Period75    res 1

c1MFlopMatch  res 1

c1BitMask     res 1
c1InputState  res 1

c1dummyLongM  res 1
